unit Msgverb;
{ If you decide to load only one of the two Message Dialogs then and use this }
{ File, you will need to comment out the type, const, Functions, and procedure}
{ defined for the Message dialog you do not wish to use.  If you do not wish  }
{ to use this dcu then you nees to remove MsgVerb from the user clause and    }
{ comment out the RegisterComponentEditor(TMsgBox, TMsgBoxEditor); from the   }
{ procedure Register; in the MsgBox/MsgDlg unit of the component you are      }
{ loading }
interface

uses
		{$IFDEF WIN32}
			Windows,
		{$ELSE}
			WinTypes, WinProcs,
		{$ENDIF}
		DsgnIntf;

	{ *********** declaration is for TInPutBox ********* }
Type
	 {TInPutBoxEditor = class(TDefaultEditor)
		 public
			 procedure Edit; override;
			 procedure ExecuteVerb(Index: Integer); override;
			 function GetVerb(Index: Integer): string; override;
			 function GetVerbCount: Integer; override;
		 end;
	{ ********* End Declaration ************** }
	{ ************ declaration is for TMsgDlg *********** }

  	 TMsgDlgEditor = class(TDefaultEditor)
		 public
			 procedure Edit; override;
			 procedure ExecuteVerb(Index: Integer); override;
			 function GetVerb(Index: Integer): string; override;
			 function GetVerbCount: Integer; override;
		 end;
{ ********* End Declaration ************** }

{ ************ declaration is for TMsgBox *********** }
	TMsgBoxEditor = class(TDefaultEditor)
	 public
    procedure Edit; override;
		 procedure ExecuteVerb(Index: Integer); override;
		 function GetVerb(Index: Integer): string; override;
		 function GetVerbCount: Integer; override;
	 end;
{ ********* End Declaration ************** }
implementation

uses
	 Dialogs, MsgDlg, MsgBox, {Inputbx,}Forms;
{ These strings appear on the menu when you press right mouse click when the }
{ component has focus.  VerbDlg is for MsgDlg and VerbBox is for MsgBox }
const
	{ VerbInput : Array[0..1] of string = ('Wav FileName...','Test InPutBox...') ;}
	 VerbDlg : Array[0..1] of string = ('Wav FileName...','Test MsgDlg...') ;
	 VerbBox : Array[0..1] of string = ('Wav FileName...','Test MsgBox...') ;

{ ************ declaration is for TMsgBox *********** }
{ You get here from double mouse click }
{procedure TInPutBoxEditor.Edit;
begin
	 TInPutBox( Component ).Execute
end;

{ You get here from a mouse click on }
{procedure TInPutBoxEditor.ExecuteVerb(Index: Integer);
var
	TheOpenDialog: TOpenDialog;

	begin
		if Index = 0 then { First Item 'Wav FileName...'}
	 {		try
			 TheOpenDialog := TOpenDialog.Create(Application);
			 with TheOpenDialog do
				 begin
					 InitialDir := 'c:\';
					 DefaultExt := 'WAV';
					 Filter := 'Wav Files|*.WAV';
				 if Execute then
					 begin
						 TInPutBox( Component ).WavFileName := FileName;
						 Designer.Modified;
					 end;
				 end;{with}
{			finally
				TheOpenDialog.Free;
			end{try finaly}
	{	else if Index = 1 then { second item 'Test MsgBox...'}
	 {			TInPutBox( Component ).Execute
end; {proc}
{ Get menu Item string }
{function TInPutBoxEditor.GetVerb(Index: Integer): string;
begin
	 Result := VerbInput[Index]
end;
{ determine how many menu items to add }
{function TInPutBoxEditor.GetVerbCount: Integer;
begin
	 Result := High(VerbInput) + 1;
end;
{ ********* End Declaration ************** }

{ ************ declaration is for TDlgBox *********** }

{ You get here from a double mouse click }
procedure TMsgDlgEditor.Edit;
begin
	 TMsgDlg( Component ).Execute
end;
{ You get here from a mouse click }
procedure TMsgDlgEditor.ExecuteVerb(Index: Integer);
var
	TheOpenDialog: TOpenDialog;

	begin
	 if Index = 0 then { First Item 'Wav FileName...'}
  begin
    TheOpenDialog := TOpenDialog.Create(Application);
	   try
      with TheOpenDialog do
		   begin
			   InitialDir := 'c:\';
			   DefaultExt := 'WAV';
			   Filter := 'Wav Files|*.WAV';
			   if Execute then
			   	begin
				  	TMsgDlg( Component ).WavFileName := FileName;
				  	Designer.Modified;
				  end;
		   	end;{with}
 		 finally
			 TheOpenDialog.Free;
	   end;{try finaly}
  end
	 else if Index = 1 then { second item 'Test MsgDlg...'}
     TMsgDlg( Component ).Execute
end; {proc}

function TMsgDlgEditor.GetVerb(Index: Integer): string;
begin
	 Result := VerbDlg[Index]
end;

function TMsgDlgEditor.GetVerbCount: Integer;
begin
	 Result := High(VerbDlg) + 1;
end;
{ ********* End Declaration ************** }

{ ************ declaration is for TMsgBox *********** }
{ You get here from double mouse click }
procedure TMsgBoxEditor.Edit;
begin
	 TMsgBox( Component ).Execute
end;

{ You get here from a mouse click on }
procedure TMsgBoxEditor.ExecuteVerb(Index: Integer);
var
	TheOpenDialog: TOpenDialog;

	begin
		if Index = 0 then { First Item 'Wav FileName...'}
   begin
     TheOpenDialog := TOpenDialog.Create(Application);
			try
       with TheOpenDialog do
			    begin
				    InitialDir := 'c:\';
					  DefaultExt := 'WAV';
					  Filter := 'Wav Files|*.WAV';
				    if Execute then
					  begin
						  TMsgBox( Component ).WavFileName := FileName;
						  Designer.Modified;
					  end;
				  end;{with}
			finally
				TheOpenDialog.Free;
			end;{try finaly}
   end
		else if Index = 1 then { second item 'Test MsgBox...'}
				TMsgBox( Component ).Execute
end; {proc}
{ Get menu Item string }
function TMsgBoxEditor.GetVerb(Index: Integer): string;
begin
	 Result := VerbBox[Index]
end;
{ determine how many menu items to add }
function TMsgBoxEditor.GetVerbCount: Integer;
begin
	 Result := High(VerbBox) + 1;
end;
{ ********* End Declaration ************** }
end.
